SystemOrganization addCategory: #'Voyage-Mongo-Utils'!

Object subclass: #VOMongoDictionaryTransformer
	instanceVariableNames: 'keyPairs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Utils'!

!VOMongoDictionaryTransformer commentStamp: 'EstebanLorenzano 3/30/2012 17:38' prior: 0!
I keep a dictionary in a way mongo can write it (otherwise, mongo will attept to put it as 'string'->[mongo value], and that is not always the case)

Example: 
======

mongoProperties
	<mongoDescription: 'properties'>
	
	^VOMongoToManyEmbededDescription new
		accessor: (MAPluggableAccessor 
			read: [ :anObject | (VOMongoDictionaryKeeper from: anObject properties) keysAndValues ]
			write: [ :anObject :value | anObject properties: value asDictionary ]);
		yourself!

!VOMongoDictionaryTransformer class methodsFor: 'accessing' stamp: 'EstebanLorenzano 4/19/2012 17:11'!
defaultKeyPairClass 
	^VOMongoKeyPair! !

!VOMongoDictionaryTransformer class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 4/19/2012 13:31'!
fromCollection: aDictionary
	^self basicNew 
		initializeCollection: aDictionary;
		yourself! !

!VOMongoDictionaryTransformer class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 4/19/2012 17:10'!
fromDictionary: aDictionary
	^self 
		kind: self defaultKeyPairClass 
		fromDictionary: aDictionary! !

!VOMongoDictionaryTransformer class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 4/19/2012 13:53'!
kind: keyPairClass fromDictionary: aDictionary
	^self basicNew 
		initializeKind: keyPairClass dictionary: aDictionary;
		yourself! !

!VOMongoDictionaryTransformer class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 3/30/2012 17:35'!
new 
	self error: 'Use #from:'! !

!VOMongoDictionaryTransformer methodsFor: 'converting' stamp: 'EstebanLorenzano 4/19/2012 13:27'!
asCollection 
	^ self keyPairs! !

!VOMongoDictionaryTransformer methodsFor: 'converting' stamp: 'EstebanLorenzano 4/19/2012 13:27'!
asDictionary 
	^keyPairs 
		inject: Dictionary new 
		into: [ :dict :each | 
			dict 
				at: each key put: each value;
				yourself ]! !

!VOMongoDictionaryTransformer methodsFor: 'initialization' stamp: 'EstebanLorenzano 4/19/2012 13:32'!
initializeCollection: aCollection
	self initialize.
	keyPairs := aCollection! !

!VOMongoDictionaryTransformer methodsFor: 'initialization' stamp: 'EstebanLorenzano 4/19/2012 13:53'!
initializeKind: keyPairClass dictionary: aDictionary 
	self initialize.
	keyPairs := aDictionary associations 
		collect: [ :each | keyPairClass key: each key value: each value ]! !

!VOMongoDictionaryTransformer methodsFor: 'converting' stamp: 'EstebanLorenzano 4/19/2012 13:34'!
keyPairs
	^keyPairs 
	! !

Object subclass: #VOMongoKeyPair
	instanceVariableNames: 'key value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Utils'!

!VOMongoKeyPair commentStamp: '<historical>' prior: 0!
I'm an association of arbitrary elements that can be persisted at mongo (in mongo, regular associations are expected to be [string, value])!

!VOMongoKeyPair class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 4/19/2012 13:36'!
key: keyObject value: valueObject
	^self basicNew 
		initializeKey: keyObject value: valueObject;
		yourself! !

!VOMongoKeyPair class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 4/19/2012 13:36'!
new 
	self error: 'Use #key:value:'! !

!VOMongoKeyPair methodsFor: 'initializing' stamp: 'EstebanLorenzano 4/19/2012 13:36'!
initializeKey: keyObject value: valueObject
	key := keyObject.
	value := valueObject.! !

!VOMongoKeyPair methodsFor: 'accessing' stamp: 'EstebanLorenzano 4/19/2012 13:35'!
key
	^key! !

!VOMongoKeyPair methodsFor: 'printing' stamp: 'EstebanLorenzano 4/19/2012 16:13'!
printOn: aStream 
	aStream 
		nextPutAll: self key asString;
		nextPutAll: '->';
		nextPutAll: self value asString! !

!VOMongoKeyPair methodsFor: 'accessing' stamp: 'EstebanLorenzano 4/19/2012 13:35'!
value
	^value! !

VOMongoKeyPair subclass: #VOMongoKeyPairReferenceValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Utils'!

!VOMongoKeyPairReferenceValue commentStamp: '<historical>' prior: 0!
I'm a dictionary of references!

!VOMongoKeyPairReferenceValue class methodsFor: 'persistence' stamp: 'EstebanLorenzano 4/19/2012 17:08'!
mongoValue 
	<mongoDescription>
	
	^VOMongoToOneReferenceDescription new
		attributeName: 'value';
		beLazy;
		yourself! !
